REST API calls /hosts/:id/puppetclasses fails with postgres
Assignee:    

Category:    

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  
Description

Calling /hosts/:id:puppetclasses fails with postgres.

The SQL request has an ORDER BY clause on a field not selected.

Suggested fix is to remove the default_scope in app/models/puppetclass.rb

Associated revisions

Revision cbf4be7c - 06/18/2012 03:30 AM - Florent Castelli

Fixes puppetclasses search with pg database

The request is sorting the results on a field that isn't in the DISTINCT

SELECT'ed columns and pg doesn't like it.

Fixes #1607

History

#1 - 05/09/2012 08:36 AM - Florent Castelli

Puppetclass Load (0.7ms)  SELECT DISTINCT puppetclasses.id FROM "puppetclasses" INNER JOIN "host_classes" ON "puppetclasses"."id" =

"host_classes"."puppetclass_id" INNER JOIN "hosts" ON "hosts"."id" = "host_classes"."host_id" WHERE (hosts.name = 'somehost') ORDER BY

LOWER

PG::Error: ERROR:  for SELECT DISTINCT, ORDER BY expressions must appear in select list

LINE 1: ...osts.name = 'somehost') ORDER BY LOWER(pupp...

^

: SELECT DISTINCT puppetclasses.id FROM "puppetclasses" INNER JOIN "host_classes" ON "puppetclasses"."id" =

"host_classes"."puppetclass_id" INNER JOIN "hosts" ON "hosts"."id" = "host_classes"."host_id" WHERE (hosts.name = 'somehost') ORDER BY

LOWER

#2 - 06/07/2012 07:58 AM - Ohad Levy

- Status changed from New to Need more information

is this still releavant? is this one of the merged pull requests and I just missed this ticket?

#3 - 06/07/2012 08:54 AM - Florent Castelli

Covered by this patch: https://github.com/theforeman/foreman/pull/55

#4 - 06/18/2012 04:43 AM - Florent Castelli

- Status changed from Need more information to Closed

- % Done changed from 0 to 100

Applied in changeset cbf4be7cfaee8c2b82c833f0f24e914ab50ef238.
